// A hand-written kernel code for multi-dimensional arrays.
// The source code is like:
// puts Array.new(10,10){ |x,y| x*10+y }.reduce(0){ |x,y| x+y }

#include <ikra.h>


inline int __ikra_body_reduce0(int x,int y) {
  return ({(x)+(y);});
}
inline int __ikra_kernel_reduce0(int* ptr, int size0, int size1, int zero) {
  int accum = zero;
  int size = size0*size1;
  for (int i = 0; i < size; i++)
    accum = __ikra_body_reduce0(accum,ptr[i]);
  return accum;
}
VALUE __ikra_wrapper_reduce0(VALUE self,VALUE wrapped_array,VALUE _size0,VALUE _size1,VALUE _unit) {
  return rb_int_new
    (__ikra_kernel_reduce0
     (get_parray(wrapped_array,int),
      NUM2INT(_size0),
      NUM2INT(_size1),
      NUM2INT(_unit)
      ));
}
inline int __ikra_body_initialize1(int x, int y) {
  return ({x*10+y;});
}
inline void __ikra_kernel_initialize1(int* ptr, int size0, int size1) {
  for (int i = 0; i < size0; i++)
    for (int j = 0; j < size1; j++)
      ptr[i*size1+j] = __ikra_body_initialize1(i,j);
}
VALUE __ikra_wrapper_initialize1(VALUE self,VALUE wrapped_array,VALUE _size0,VALUE _size1) {
    __ikra_kernel_initialize1
     (get_parray(wrapped_array,int),
      NUM2INT(_size0),
      NUM2INT(_size1)
      );
    return Qnil;
}
extern "C"
void Init_mdtest(){
  VALUE cKernel = rb_define_module("Ikra_Kernels__mdtest");
  rb_define_module_function(cKernel, "reduce0",
     (VALUE(*)(...))__ikra_wrapper_reduce0, 4);rb_define_module_function(cKernel, "initialize1",
     (VALUE(*)(...))__ikra_wrapper_initialize1, 3);
  return;
}
