type variable = string
type 'a env = Empty | Frame of 'a env * (variable * 'a) list
val empty : 'a env
exception Unbound of string
val extend : 'a env -> (variable * 'a) list -> 'a env
val lookup : 'a env -> variable -> 'a
val is_bound : 'a env -> variable -> bool
val bound_vars : 'a env -> variable list
